﻿Public Class frmMain
    Public dtTcode As New DataTable

    Private Sub frmMain_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Me.ugdTcodes.DataSource = Nothing
        Buildgrid()
    End Sub

    Public Sub Buildgrid()
        dtTcode = New DataTable

        Dim dcol As DataColumn
        dcol = New DataColumn("Tcode", GetType(String))
        dtTcode.Columns.Add(dcol)
        dcol = New DataColumn("Status", GetType(String))
        dtTcode.Columns.Add(dcol)

        Dim dRow As DataRow

        For iCounter = 0 To 100
            dRow = dtTcode.NewRow
            dRow("Tcode") = iCounter.ToString
            dRow("Status") = "active"
            dtTcode.Rows.Add(dRow)
        Next

        Me.ugdTcodes.DataSource = dtTcode
    End Sub
    Private Sub ugdTcodes_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles ugdTcodes.InitializeLayout
        e.Layout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect
        e.Layout.Override.SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType.ExtendedAutoDrag
    End Sub
    Private Sub btnSearchGrid_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearchGrid.Click

        If Me.txtSearchStringGrid.Text.Length = 0 Then Return

        Me.ugdTcodes.Focus()
        Me.ugdTcodes.DisplayLayout.Override.SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType.Single

        For Each uRow As Infragistics.Win.UltraWinGrid.UltraGridRow In Me.ugdTcodes.Rows
            If uRow.Cells("Tcode").Value.toupper = Me.txtSearchStringGrid.Text.ToUpper Then
                uRow.Activate()
                uRow.Activated = True
                uRow.Selected = True
            Else
                uRow.Selected = False
            End If
        Next

        Me.ugdTcodes.DisplayLayout.Override.SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType.ExtendedAutoDrag

        Dim sMessage As String = ""

        For Each uRow As Infragistics.Win.UltraWinGrid.UltraGridRow In Me.ugdTcodes.Rows

            If uRow.Selected = True Then
                sMessage += "Row " + uRow.Index.ToString + " is selected." + vbCrLf
            End If

            If uRow.Activated = True Then
                sMessage += "Row " + uRow.Index.ToString + " is activated." + vbCrLf
            End If

            If uRow.IsActiveRow Then
                sMessage += "Row " + uRow.Index.ToString + " is active row." + vbCrLf
            End If

        Next

        MessageBox.Show(sMessage)

    End Sub
End Class
